/*	$Id: trap.h,v 1.5 2010/01/04 22:45:09 tsubai Exp $	*/

/*-
 * Copyright (c) 2002 Tsubai Masanari.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#define EXC_RST		0x0100	/* Reset */
#define EXC_MCHK	0x0200	/* Machine Check */
#define EXC_EXI		0x0500	/* External Interrupt */
#define EXC_ALI		0x0600	/* Alignment Interrupt */
#define EXC_PGM		0x0700	/* Program Interrupt */
#define EXC_DECR	0x0900	/* Decrementer Interrupt */
#define EXC_SC		0x0c00	/* System Call */
#define EXC_TRC		0x0d00	/* Trace */

/* Implementation specific traps */
#define EXC_SOFTEMU	0x1000	/* Software emulation */
#define EXC_ITLBMISS	0x1100	/* Instruction TLB miss */
#define EXC_DTLBMISS	0x1200	/* Data TLB miss */
#define EXC_ITLBERR	0x1300	/* Instruction TLB error */
#define EXC_DTLBERR	0x1400	/* Data TLB error */
#define EXC_DBPT	0x1c00	/* Data break point */
#define EXC_IBPT	0x1d00	/* Instruction break point */
#define EXC_PBPT	0x1e00	/* Peripheral break point */
#define EXC_NMDP	0x1f00	/* Non maskable development port */

#define EXC_BPT EXC_IBPT
#define EXC_AST		0x3000	/* Fake AST vector */
#define EXC_USER	0x10000	/* Trap was in user mode */

#define DSISR_PROT	0x80000000	/* XXX ? */
#define DSISR_MISS	0x40000000
#define DSISR_STORE	0x02000000
#define DSISR_ALL	(DSISR_PROT|DSISR_MISS|DSISR_STORE)
