/*	$NetBSD: ieeefp.h,v 1.2 1999/07/07 01:52:26 danw Exp $	*/

/*
 * Written by J.T. Conklin, Apr 6, 1995
 * Public domain.
 */

#ifndef _POWERPC_IEEEFP_H_
#define _POWERPC_IEEEFP_H_

#include <sys/featuretest.h>

#if defined(_NETBSD_SOURCE) || defined(_ISOC99_SOURCE)

typedef int fenv_t;
typedef int fexcept_t;

#define FE_INEXACT	0x01	/* imprecise (loss of precision) */
#define FE_DIVBYZERO	0x02	/* divide-by-zero exception */
#define FE_UNDERFLOW	0x04	/* underflow exception */
#define FE_OVERFLOW	0x08	/* overflow exception */
#define FE_INVALID	0x10	/* invalid operation exception */

#define FE_ALL_EXCEPT	0x1f

#define FE_TONEAREST	0	/* round to nearest representable number */
#define FE_TOWARDZERO	1	/* round to zero (truncate) */
#define FE_UPWARD	2	/* round toward positive infinity */
#define FE_DOWNWARD	3	/* round toward negative infinity */

#ifndef _ISOC99_SOURCE

typedef int fp_except;
#define FP_X_IMP	0x01	/* imprecise (loss of precision) */
#define FP_X_DZ		0x02	/* divide-by-zero exception */
#define FP_X_UFL	0x04	/* underflow exception */
#define FP_X_OFL	0x08	/* overflow exception */
#define FP_X_INV	0x10	/* invalid operation exception */

typedef enum {
    FP_RN=0,			/* round to nearest representable number */
    FP_RZ=1,			/* round to zero (truncate) */
    FP_RP=2,			/* round toward positive infinity */
    FP_RM=3			/* round toward negative infinity */
} fp_rnd;

#endif /* !_ISOC99_SOURCE */
#endif /* _NETBSD_SOURCE || _ISOC99_SOURCE */

#endif /* _POWERPC_IEEEFP_H_ */
